*! version 1.2    8dec06 -- pbe
*! version 1.1.2 23oct08, 23Mar00 -- pbe
program define pprob
  version 8.0
  syntax  , Mean(real) [ n(integer 10) SAVing(string) notable GRAph *]
  preserve
  drop _all
  local n = `n' + 1
  quietly set obs `n'
  generate k = _n - 1
  generate pprob = (exp(-1*`mean')*`mean'^k)/(exp(lnfact(k)))
  generate pcum = sum(pprob)
  format pprob pcum %9.8f
  format k %4.0f
  if "`table'" == "" {
    display
    display " Poisson Probabilities for lambda = `mean'"
    list
  }
  format pprob %3.2g
  if "`graph'" ~= "" {
    twoway connected pprob k , ylabel(0 .1 to .3) ///
      title("Poisson: mean = `mean'")  ///
      `options'
  }
  if "`saving'" ~= "" {
    sort k
    quietly save "`saving'"
  }
  restore
end
